diff --git a/lib/dns/resolver.c b/lib/dns/resolver.c
index 7d443fd55b..3c0e3013aa 100644
--- a/lib/dns/resolver.c
+++ b/lib/dns/resolver.c
@@ -4020,6 +4020,15 @@ fctx_nextaddress(fetchctx_t *fctx) {
 			addrinfo->flags |= FCTX_ADDRINFO_MARK;
 			fctx->find = NULL;
 			fctx->forwarding = true;
+
+			/*
+			 * QNAME minimization is disabled when
+			 * forwarding, and has to remain disabled if
+			 * we switch back to normal recursion; otherwise
+			 * forwarding could leave us in an inconsistent
+			 * state.
+			 */
+			fctx->minimized = false;
 			return (addrinfo);
 		}
 	}
